package gyak4;

import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.table.AbstractTableModel;


public class TableModel extends JFrame implements TableModelListener{
     public TableModel(){
        setTitle("Gyak4");
        setDefaultCloseOperation(EXIT_ON_CLOSE);
        setSize(400, 200);
        
        setTable();
    }
     
     private void setTable(){
        JTable table = new JTable(new MyTableModel());
        table.getModel().addTableModelListener(this);
        table.setAutoCreateRowSorter(true);
        
        JScrollPane scrollPane = new JScrollPane(table);
        add(scrollPane);
     }

     
    @Override
    public void tableChanged(TableModelEvent e) {
        int row = e.getFirstRow();
        int column = e.getColumn();
        MyTableModel model = (MyTableModel)e.getSource();
        String columnName = model.getColumnName(column);
        Object data = model.getValueAt(row, column);//Ez persze már a megváltozott érték
        System.out.println("row: " + row + " , column: " + column  + " ,data: " + data);
    }
     
    private class MyTableModel extends AbstractTableModel{
        private String[] columns = {"First Name", "Second Name", "Male", "Age"};
        
        private Object[][] data = {
            {"Kiss", "Pista", true, new Integer(35)},
            {"Kiss", "Petra", false, new Integer(30)},
            {"Kiss", "István", true, new Integer(61)},
            {"Kiss", "Zsófia", false, new Integer(58)},
        };
        
        
        //kötelező felülírni
        @Override
        public int getRowCount() {
            return data.length;
        }

        //kötelező felülírni
        @Override
        public int getColumnCount() {
            return columns.length;
        }

        //kötelező felülírni
        @Override
        public Object getValueAt(int arg0, int arg1) {
            return data[arg0][arg1];
        }
        
        //A következőket már nem muszáj felülírni, de ajánlott, hiszen:
        
        //Ez szükséges, hogy legyen az oszlopainknak neve
        @Override
        public String getColumnName(int col) {
            return columns[col];
        }
        
        //A megfelelő megjelenítéshez szüksgéges(checkbox/integer)
        @Override
        public Class getColumnClass(int c) {
            return getValueAt(0, c).getClass();
        }
        
        //alapból nem lehet változtatni a táblázat értékeit.
        @Override
        public boolean isCellEditable(int row, int col) {   
            if (col < 2) {
                return false;
            } else {
                return true;
            }
        }
        
        //Ha ezt nem írjuk felül, akkor nem menti a változtatásokat
        @Override
        public void setValueAt(Object value, int row, int col) {
            data[row][col] = value;
            fireTableCellUpdated(row,col);//Ez értesíti az összes listenert( a TableModelListener is), hogy változás történt
        }
    }
}
