package gyak4mo;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.util.LinkedList;
import java.util.List;
import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.JToolBar;
import javax.swing.table.AbstractTableModel;


public class TableModel extends JFrame {
    
    private JTextField textField;
    private JComboBox<Integer> comboBox;
    private JCheckBox checkBox;
    private MyTableModel tableModel;
   
     public TableModel(){
        setTitle("Gyak4");
        setDefaultCloseOperation(EXIT_ON_CLOSE);
        setSize(400, 200);
        
        textField = new JTextField();
        Integer[] szamok = {2014,2015,2016,2017,2018};
        comboBox = new JComboBox<Integer>(szamok);
        checkBox = new JCheckBox();
        
        setLayout(new BorderLayout());
        JToolBar toolBar = new JToolBar();
        add(toolBar,BorderLayout.NORTH);
        toolBar.add(rogzitAction);
        toolBar.add(textField);
        toolBar.add(comboBox);
        toolBar.add(checkBox);
        
        setTable();
    }
     
     private void setTable(){
        
        tableModel = new MyTableModel();
        JTable table = new JTable(tableModel);
        table.setAutoCreateRowSorter(true);
        
        JScrollPane scrollPane = new JScrollPane(table);
        add(scrollPane, BorderLayout.CENTER);
     }
     
     private final Action rogzitAction = new AbstractAction("Rögzít") {
        @Override
        public void actionPerformed(ActionEvent e) {
            String name = textField.getText();
            textField.setText("");
            int year = comboBox.getSelectedIndex() + 2014;
            comboBox.setSelectedIndex(0);
            boolean check = checkBox.isSelected();
            checkBox.setSelected(false);
            tableModel.addSor(name, year, check);
        }
    };

     
    private class MyTableModel extends AbstractTableModel{
        private String[] columns = {"Termék név", "Lejárati év", "Elérhető"};
        
        
        private List<Sor> data = new LinkedList<Sor>();
        
        public void addSor(String product, int year, boolean available){
            data.add(new Sor(product, year, available));
            fireTableDataChanged();//itt jelezzük, hogy a (teljes) táblázat változott, ezért azt újra kell rajzolni!
        }
        
        //kötelező felülírni
        @Override
        public int getRowCount() {
            return data.size();
        }

        //kötelező felülírni
        @Override
        public int getColumnCount() {
            return columns.length;
        }

        //kötelező felülírni
        @Override
        public Object getValueAt(int arg0, int arg1) {
            Sor s = data.get(arg0);
            switch(arg1){
                case 0:
                    return s.getTermek();
                case 1:
                    return s.getLejarat();
                case 2:
                    return s.isElerheto();
                default:
                    return null;
            }
        }
        
        //A következőket már nem muszáj felülírni, de ajánlott, hiszen:
        
        //Ez szükséges, hogy legyen az oszlopainknak neve
        @Override
        public String getColumnName(int col) {
            return columns[col];
        }
        
        //A megfelelő megjelenítéshez szüksgéges(checkbox/integer)
        @Override
        public Class getColumnClass(int c) {
            return getValueAt(0, c).getClass();
        }
        
        //alapból nem lehet változtatni a táblázat értékeit.
        @Override
        public boolean isCellEditable(int row, int col) {   
            return false;
        }
        
        //Ha ezt nem írjuk felül, akkor nem menti a változtatásokat
        @Override
        public void setValueAt(Object value, int row, int col) {
            switch(col){
                case 0:
                    data.get(row).setTermek((String)value);
                case 1:
                    data.get(row).setLejarat((Integer)value);
                case 2:
                    data.get(row).setElerheto((Boolean)value);
                default:
            }
            fireTableCellUpdated(row,col);//Ez értesíti az összes listenert( a TableModelListener is), hogy változás történt
        }
    }
}
