package swingtables.gui;

import javax.swing.table.AbstractTableModel;
import swingtables.logic.DataSource;
import swingtables.logic.DataSourceListener;
import swingtables.logic.WikipediaPageInfo;

public class WikipediaPageInfoTableModel extends AbstractTableModel {

    @Override
    public int getRowCount() {
        return DataSource.getInstance().getWikipediaPageInfos().size();
    }

    @Override
    public int getColumnCount() {
        return WikipediaPageInfo.propertyNames.length;
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        WikipediaPageInfo wpi = DataSource.getInstance().getWikipediaPageInfos().get(rowIndex);
        switch (columnIndex) {
            case 0:
                return wpi.getTitle();
            case 1:
                return wpi.getUrl();
            case 2:
                return wpi.getPageID();
            case 3:
                return wpi.getLength();
            case 4:
                return wpi.getTouched();
            default:
                return null;
        }
    }

    @Override
    public String getColumnName(int column) {
        return WikipediaPageInfo.propertyNames[column];
    }

    @Override
    public Class<?> getColumnClass(int columnIndex) {
        if (getRowCount() > 0) {
            return getValueAt(0, columnIndex).getClass();
        } else {
            return null;
        }
    }

    public WikipediaPageInfoTableModel() {
        DataSource.getInstance().addDataSourceListener(new DataSourceListener() {
            @Override
            public void wikipediaPageInfoLoaded(WikipediaPageInfo wikipediaPageInfo) {
                fireTableDataChanged();
            }
        });
    }
}
